package cz.cuni.mff.emoticonposhbot_c;

import cz.cuni.amis.pogamut.emohawk.agent.module.sensomotoric.AnimType;
import cz.cuni.amis.pogamut.emohawk.agent.module.sensomotoric.Emoticon;
import cz.cuni.amis.pogamut.emohawk.agent.module.sensomotoric.EmoticonBubbleType;
import cz.cuni.amis.pogamut.emohawk.agent.module.sensomotoric.EmoticonType;
import cz.cuni.amis.pogamut.sposh.context.EmohawkContext;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 * Action that causes bot to randommly change the thought emoticon.
 * 
 * @author Jimmy
 */
@SuppressWarnings("rawtypes")
@PrimitiveInfo(name = "changeMood", description = "Randomly switch the thought emoticon.")
public class ChangeMood extends StateAction<EmohawkContext>
{

    public ChangeMood(EmohawkContext ctx)
    {
        super("changeMood", ctx);
    }

    @Override
    public void init(VariableContext params)
    {
    }

    @Override
    public ActionResult run(VariableContext params)
    {
        // it is adviced to always log your actions in order for you to get a grasp on how SPOSH is evaluating the plan
        ctx.getLog().info("changeMood()");

        final Player player = ctx.getInfo().getNearestVisiblePlayer();
        if (player == null)
            return ActionResult.RUNNING_ONCE;

        final EmoticonType emotCenter = EmoticonType.get(player.getEmotCenter());
        final EmoticonType emotLeft = EmoticonType.get(player.getEmotLeft());
        final EmoticonType emotRight = EmoticonType.get(player.getEmotRight());

        if (emotCenter.equals(EmoticonType.HEART_194) && Math.random() > 0.8) {
            if (emotLeft.equals(EmoticonType.CANDY_186)) {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.BEER_82, EmoticonType.HEART_194,
                                EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
            } else if (emotLeft.equals(EmoticonType.CINEMA_40)
                    && (!ctx.getEmoticons().getCurrentCenterEmoticonType().equals(EmoticonType.ARGUING_SMILEYS_165) || Math
                            .random() > 0.5)) {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.HAHAHA_CZ_133, EmoticonType.HEART_194,
                                EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
            } else {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.CINEMA_40, EmoticonType.HEART_194, EmoticonType.BED_85,
                                EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
            }
            ctx.getAnimations().playAnimationSafe(AnimType.AMBI_STAND_SEXY, true);
        } else if (emotCenter.equals(EmoticonType.ARGUING_SMILEYS_165) && Math.random() > 0.8) {
            if (emotLeft.equals(EmoticonType.BULLSHIT_CZ_140) || emotRight.equals(EmoticonType.ANGRY_SMILEY_163)) {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.DYNAMITE_174, EmoticonType.ARGUING_SMILEYS_165,
                                EmoticonType.CHEMICAL_FORMULA_32, EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
                ctx.getAnimations().playAnimationSafe(AnimType.AMBI_STAND_ANGRY02, true);
            } else if (Math.random() > 0.5) {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.WOW_227, EmoticonType.HEART_194, EmoticonType.FACEBOOK_131,
                                EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
                ctx.getAnimations().playAnimationSafe(AnimType.AMBI_STAND_HAPPY, true);
            } else if (emotLeft.equals(EmoticonType.DYNAMITE_174) || emotRight.equals(EmoticonType.CHEMICAL_FORMULA_32)) {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.BULLSHIT_CZ_140, EmoticonType.ARGUING_SMILEYS_165,
                                EmoticonType.ANGRY_SMILEY_163, EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
                ctx.getAnimations().playAnimationSafe(AnimType.AMBI_STAND_ANGRY03, true);
            }
        } else {
            if (Math.random() > 0.5) {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.CANDY_186, EmoticonType.HEART_194, EmoticonType.FIRST_GIRL_68,
                                EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
                ctx.getAnimations().playAnimationSafe(AnimType.AMBI_STAND_HAPPY, true);
            } else {
                ctx.getEmoticons().setEmoticon(
                        new Emoticon(EmoticonType.BULLSHIT_CZ_140, EmoticonType.ARGUING_SMILEYS_165,
                                EmoticonType.ANGRY_SMILEY_163, EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER));
                ctx.getAnimations().playAnimationSafe(AnimType.AMBI_SMSREAD, true);
            }
        }

        return ActionResult.RUNNING_ONCE;
    }

    @Override
    public void done(VariableContext params)
    {
    }
}
