package cz.cuni.mff.emoticonposhbot_c;

import cz.cuni.amis.pogamut.sposh.context.EmohawkContext;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 * If I am far away from other players.
 * 
 * @author Honza
 */
@SuppressWarnings("rawtypes")
@PrimitiveInfo(name = "isFarAway", description = "If I am far away from other players.")
public class IsFarAway extends StateSense<EmohawkContext, Boolean>
{

    public IsFarAway(EmohawkContext ctx)
    {
        super("isFarAway", ctx);
    }

    @Override
    public Boolean query(VariableContext params)
    {
        Player player = ctx.getInfo().getNearestVisiblePlayer();
        if (player == null)
            return false;

        return player.getLocation().getDistance(ctx.getInfo().getLocation()) > 500;
    }
}
