package cz.cuni.mff.emoticonposhbot_c;

import SteeringProperties.ObstacleAvoidanceProperties;
import SteeringProperties.SteeringProperties.BehaviorType;
import SteeringProperties.TargetApproachingProperties;
import cz.cuni.amis.pogamut.emohawk.agent.module.sensomotoric.AnimType;
import cz.cuni.amis.pogamut.sposh.context.EmohawkContext;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 * Goes to the neares visible player.
 * 
 * @author Martin Pecka
 */
@SuppressWarnings("rawtypes")
@PrimitiveInfo(name = "walkToNearestPlayer", description = "Goes to the neares visible player.")
public class WalkToNearestPlayer extends StateAction<EmohawkContext>
{

    public WalkToNearestPlayer(EmohawkContext ctx)
    {
        super("walkToNearestPlayer", ctx);
    }

    @Override
    public void init(VariableContext params)
    {
        ctx.getSteering().startNavigation();
        ctx.getSteering().addObstacleAvoidanceSteering(new ObstacleAvoidanceProperties(BehaviorType.ADVANCED));
        ctx.getSteering().addTargetApproachingSteering(new TargetApproachingProperties(BehaviorType.ADVANCED));

        ctx.getAnimations().playAnimationSafe(AnimType.WALK_HAPPY, true);
    }

    @Override
    public ActionResult run(VariableContext params)
    {
        final Player player = ctx.getInfo().getNearestVisiblePlayer();
        if (player == null)
            return ActionResult.RUNNING;

        ctx.getMove().turnTo(player);
        ctx.getSteering().getTargetApproachingProperties().setTargetLocation(0, player.getLocation());

        return ActionResult.RUNNING;
    }

    @Override
    public void done(VariableContext params)
    {
        ctx.getSteering().stopNavigation();
    }
}
